local Semicombat;
SF_Player_Locked = true;
SF_Target_Locked = true;
SF_TargetofTarget_Locked = true;

SF_Castbar_State = true;
SF_Gryphon_State = true;
SF_Bags_State = true;
SF_MicroMenu_State = true;
SF_Keyring_State = true;

Semi_Player_Scale = 1.0;

local Semiclass = UnitClass("player");

function Semi_Core_OnLoad()
		--Setting Inital Text for Menu
	Semi_CoreOptionsTitle:SetText(Semi_Core_String_Version);
	if (SF_Bags_State) then
		Semi_CoreOptionsCheckButton1Text:SetText(Semi_Core_String_CB1a);
	elseif (not SF_Bags_State) then
		Semi_CoreOptionsCheckButton1Text:SetText(Semi_Core_String_CB1b);
	end
	if (SF_MicroMenu_State) then
		Semi_CoreOptionsCheckButton2Text:SetText(Semi_Core_String_CB2a);
	elseif (not SF_MicroMenu_State) then
		Semi_CoreOptionsCheckButton2Text:SetText(Semi_Core_String_CB2b);
	end
	
	Semi_CoreOptionsCheckButton3Text:SetText(Semi_Core_String_CB3c);
	
	if (SF_Castbar_State) then
		Semi_CoreOptionsCheckButton4Text:SetText(Semi_Core_String_CB4a);
	elseif (not SF_Castbar_State) then
		Semi_CoreOptionsCheckButton4Text:SetText(Semi_Core_String_CB4b);
	end
	if (SF_Gryphon_State) then
		Semi_CoreOptionsCheckButton5Text:SetText(Semi_Core_String_CB5a);
	elseif (not SF_Gryphon_State) then
		Semi_CoreOptionsCheckButton5Text:SetText(Semi_Core_String_CB5b);
	end
	
	Semi_CoreOptionsButton1:SetText(Semi_Core_String_B1);
	Semi_CoreOptionsButton2:SetText(Semi_Core_String_B2);
	Semi_CoreOptionsButton3:SetText(Semi_Core_String_B3);
	Semi_CoreOptionsButton4:SetText(Semi_Core_String_B4);
		Semi_CoreOptionsButton4:Disable();
	
		--Setting Inital Text for Modules Menu
	Semi_CoreOptions_ModsTitle:SetText(Semi_Core_Mods_String_Title);
	Semi_CoreOptions_ModsCheckButton1Text:SetText(Semi_Core_Mods_String_CB1a);
	Semi_CoreOptions_ModsCheckButton2Text:SetText(Semi_Core_Mods_String_CB2a);
	Semi_CoreOptions_ModsCheckButton3Text:SetText(Semi_Core_Mods_String_CB3a);
	Semi_CoreOptions_ModsCheckButton4Text:SetText(Semi_Core_Mods_String_CB4a);
	Semi_CoreOptions_ModsCheckButton5Text:SetText(Semi_Core_Mods_String_CB5a);
	Semi_CoreOptions_ModsCheckButton6Text:SetText(Semi_Core_Mods_String_CB6a);
	Semi_CoreOptions_ModsCheckButton7Text:SetText(Semi_Core_Mods_String_CB7a);
	Semi_CoreOptions_ModsCheckButton8Text:SetText(Semi_Core_Mods_String_CB8a);
	Semi_CoreOptions_ModsButton1:SetText(Semi_Core_Mods_String_B1);
	Semi_CoreOptions_ModsButton2:SetText(Semi_Core_Mods_String_B2);
	
	DEFAULT_CHAT_FRAME:AddMessage("|cff00bfffSemi - version|r 1.0 |cff00ff00- loaded.|r  |cffffd700/semi|r |cff00bffffor Options Menu.|r");
					
end

function Semi_CoreOptions_OnShow()
	if (IsAddOnLoaded("Semi_Action_Bars")) then
		if (SF_Bags_State) then
			Semi_CoreOptionsCheckButton1:SetChecked(true);
			Semi_CoreOptionsCheckButton1Text:SetText(Semi_Core_String_CB1a);
		end
		if (not SF_Bags_State) then
			Semi_CoreOptionsCheckButton1:SetChecked(false);
			Semi_CoreOptionsCheckButton1Text:SetText(Semi_Core_String_CB1b);
		end
		if (SF_MicroMenu_State) then
			Semi_CoreOptionsCheckButton2:SetChecked(true);
			Semi_CoreOptionsCheckButton2Text:SetText(Semi_Core_String_CB2a);
		end
		if (not SF_MicroMenu_State) then
			Semi_CoreOptionsCheckButton2:SetChecked(false);
			Semi_CoreOptionsCheckButton2Text:SetText(Semi_Core_String_CB2b);
		end
		if (SF_Keyring_State) then
			Semi_CoreOptionsCheckButton3:SetChecked(true);
			Semi_CoreOptionsCheckButton3Text:SetText(Semi_Core_String_CB3a);
		end
		if (not SF_Keyring_State) then
			Semi_CoreOptionsCheckButton3:SetChecked(false);
			Semi_CoreOptionsCheckButton3Text:SetText(Semi_Core_String_CB3b);
		end
	end
	if (not IsAddOnLoaded("Semi_Action_Bars")) then
			Semi_CoreOptionsCheckButton1:Disable();
			Semi_CoreOptionsCheckButton1Text:SetText(Semi_Core_String_CB1c);
			Semi_CoreOptionsCheckButton2:Disable();
			Semi_CoreOptionsCheckButton2Text:SetText(Semi_Core_String_CB2c);
			Semi_CoreOptionsCheckButton3:Disable();
			Semi_CoreOptionsCheckButton3Text:SetText(Semi_Core_String_CB3c);
	end	
	
	if (SF_Castbar_State) then
		Semi_CoreOptionsCheckButton4:SetChecked(true);
		Semi_CoreOptionsCheckButton4Text:SetText(Semi_Core_String_CB4a);
	else
		Semi_CoreOptionsCheckButton4:SetChecked(false);
		Semi_CoreOptionsCheckButton4Text:SetText(Semi_Core_String_CB4b);
	end
	if (SF_Gryphon_State) then
		Semi_CoreOptionsCheckButton5:SetChecked(true);
		Semi_CoreOptionsCheckButton5Text:SetText(Semi_Core_String_CB5a);
	else
		Semi_CoreOptionsCheckButton5:SetChecked(false);
		Semi_CoreOptionsCheckButton5Text:SetText(Semi_Core_String_CB5b);
	end
	
	if (IsAddOnLoaded("Semi_Extra_Bars")) then
		SF_EB_1_State = Semi_Bar1_ActionBar;
		SF_EB_2_State = Semi_Bar2_ActionBar;
		SF_EB_3_State = Semi_Bar3_ActionBar;
		Semi_CoreOptionsCheckButton6:SetChecked(SF_EB_1_State);
		if (SF_EB_1_State) then 
			Semi_CoreOptionsCheckButton6Text:SetText(Semi_Core_String_CB6a);
		end
		if (not SF_EB_1_State) then
			Semi_CoreOptionsCheckButton6Text:SetText(Semi_Core_String_CB6b);
		end
		Semi_CoreOptionsCheckButton7:SetChecked(SF_EB_2_State);
		if (SF_EB_2_State) then
			Semi_CoreOptionsCheckButton7Text:SetText(Semi_Core_String_CB7a);
		end
		if (not SF_EB_2_State) then
			Semi_CoreOptionsCheckButton7Text:SetText(Semi_Core_String_CB7b);
		end
		Semi_CoreOptionsCheckButton8:SetChecked(SF_EB_3_State);
		if (SF_EB_3_State) then
			Semi_CoreOptionsCheckButton8Text:SetText(Semi_Core_String_CB8a);
		end
		if (not SF_EB_3_State) then
			Semi_CoreOptionsCheckButton8Text:SetText(Semi_Core_String_CB8b);
		end
		Semi_CoreOptionsCheckButton9:SetChecked(Semi_Grid);
		if (Semi_Grid) then
			Semi_CoreOptionsCheckButton9Text:SetText(Semi_Core_String_CB9a);
		end
		if (not Semi_Grid) then
			Semi_CoreOptionsCheckButton9Text:SetText(Semi_Core_String_CB9b);
		end
	end
	if (not IsAddOnLoaded("Semi_Extra_Bars")) then
		Semi_CoreOptionsCheckButton6:Disable();
		Semi_CoreOptionsCheckButton6:Hide();
		Semi_CoreOptionsCheckButton7:Disable();
		Semi_CoreOptionsCheckButton7:Hide();
		Semi_CoreOptionsCheckButton8:Disable();
		Semi_CoreOptionsCheckButton8:Hide();
		Semi_CoreOptionsCheckButton9:Disable();
		Semi_CoreOptionsCheckButton9:Hide();
	end
end

function Semi_CoreOptions_Mods_OnShow()
	if (not IsAddOnLoaded("Semi_Player_Frame")) then
 		Semi_CoreOptions_ModsCheckButton1:SetChecked(false);
		Semi_CoreOptions_ModsCheckButton1Text:SetText(Semi_Core_Mods_String_CB1b);
	else 
		Semi_CoreOptions_ModsCheckButton1:SetChecked(true);
		Semi_CoreOptions_ModsCheckButton1Text:SetText(Semi_Core_Mods_String_CB1a);
	end
	if (not IsAddOnLoaded("Semi_Target_Frame")) then
		Semi_CoreOptions_ModsCheckButton2:SetChecked(false);
		Semi_CoreOptions_ModsCheckButton2Text:SetText(Semi_Core_Mods_String_CB2b);
	else
		Semi_CoreOptions_ModsCheckButton2:SetChecked(true);
		Semi_CoreOptions_ModsCheckButton2Text:SetText(Semi_Core_Mods_String_CB2a);
	end
	if (not IsAddOnLoaded("Semi_TargetofTarget_Frame")) then
		Semi_CoreOptions_ModsCheckButton3:SetChecked(false);
		Semi_CoreOptions_ModsCheckButton3Text:SetText(Semi_Core_Mods_String_CB3b);
	else
		Semi_CoreOptions_ModsCheckButton3:SetChecked(true);
		Semi_CoreOptions_ModsCheckButton3Text:SetText(Semi_Core_Mods_String_CB3a);
	end
	if (not IsAddOnLoaded("Semi_ClassIcons_Portrait")) then
		Semi_CoreOptions_ModsCheckButton4:SetChecked(false);
		Semi_CoreOptions_ModsCheckButton4Text:SetText(Semi_Core_Mods_String_CB4b);
	else
		Semi_CoreOptions_ModsCheckButton4:SetChecked(true);
		Semi_CoreOptions_ModsCheckButton4Text:SetText(Semi_Core_Mods_String_CB4a);
	end
	if (not IsAddOnLoaded("Semi_Action_Bars")) then
		Semi_CoreOptions_ModsCheckButton5:SetChecked(false);
		Semi_CoreOptions_ModsCheckButton5Text:SetText(Semi_Core_Mods_String_CB5b);
	else
		Semi_CoreOptions_ModsCheckButton5:SetChecked(true);
		Semi_CoreOptions_ModsCheckButton5Text:SetText(Semi_Core_Mods_String_CB5a);
	end
	
	if (not IsAddOnLoaded("Semi_Extra_Bars")) then
		Semi_CoreOptions_ModsCheckButton6:SetChecked(false);
		Semi_CoreOptions_ModsCheckButton6Text:SetText(Semi_Core_Mods_String_CB6b);
	else
		Semi_CoreOptions_ModsCheckButton6:SetChecked(true);
		Semi_CoreOptions_ModsCheckButton6Text:SetText(Semi_Core_Mods_String_CB6a);
	end
	
	if (not IsAddOnLoaded("Semi_Pet_Bar")) then
		Semi_CoreOptions_ModsCheckButton7:SetChecked(false);
		Semi_CoreOptions_ModsCheckButton7Text:SetText(Semi_Core_Mods_String_CB7b);
	else
		Semi_CoreOptions_ModsCheckButton7:SetChecked(true);
		Semi_CoreOptions_ModsCheckButton7Text:SetText(Semi_Core_Mods_String_CB7a);
	end
	
	if (not IsAddOnLoaded("Semi_Stance_Bar")) then
		Semi_CoreOptions_ModsCheckButton8:SetChecked(false);
		Semi_CoreOptions_ModsCheckButton8Text:SetText(Semi_Core_Mods_String_CB8b);
	else
		Semi_CoreOptions_ModsCheckButton8:SetChecked(true);
		Semi_CoreOptions_ModsCheckButton8Text:SetText(Semi_Core_Mods_String_CB8a);
	end
end


function Semi_Player_Scale_On_Change(Semi_Player_Scale)
	PlayerFrame:SetScale(Semi_Player_Scale);
end	

function Semi_Bags_Options()
	SF_Bags_State = Semi_CoreOptionsCheckButton1:GetChecked() or false;
	if (SF_Bags_State) then
		ShowSemiBags();
		Semi_CoreOptionsCheckButton1Text:SetText(Semi_Core_String_CB1a);
		Semi_LinkInventoryBagsToDragButton();
	end
	if (not SF_Bags_State) then
		HideSemiBags();
		Semi_CoreOptionsCheckButton1Text:SetText(Semi_Core_String_CB1b);
	end
end

function Semi_MicroMenu_Options()
	SF_MicroMenu_State = Semi_CoreOptionsCheckButton2:GetChecked() or false;
	if (SF_MicroMenu_State) then
		ShowSemiMenu();
		Semi_CoreOptionsCheckButton2Text:SetText(Semi_Core_String_CB2a);
		Semi_LinkMicroMenuToDragButton();
	end
	if (not SF_MicroMenu_State) then
		HideSemiMenu();
		Semi_CoreOptionsCheckButton2Text:SetText(Semi_Core_String_CB2b);
	end
end

function Semi_Keyring_Options()
	SF_Keyring_State = Semi_CoreOptionsCheckButton3:GetChecked() or false;
	if (SF_Keyring_State) then
			KeyRingButton:Show();
			SF_Key_State = "true"
			Semi_CoreOptionsCheckButton3Text:SetText(Semi_Core_String_CB3a);
	end
	if (not SF_Keyring_State) then
			KeyRingButton:Hide();
			SF_Key_State = "false";
			Semi_CoreOptionsCheckButton3Text:SetText(Semi_Core_String_CB3b);
	end
		
end

function Semi_ExtraBar1_Options()
	SF_EB_1_State = Semi_CoreOptionsCheckButton6:GetChecked() or false;
	if (SF_EB_1_State) then
		Semi_Bar1_ShowBar();
		Semi_CoreOptionsCheckButton6Text:SetText(Semi_Core_String_CB6a);
	end
	if (not SF_EB_1_State) then
		Semi_Bar1_HideBar();
		Semi_CoreOptionsCheckButton6Text:SetText(Semi_Core_String_CB6b);
	end
end

function Semi_ExtraBar2_Options()
	SF_EB_2_State = Semi_CoreOptionsCheckButton7:GetChecked() or false;
	if (SF_EB_2_State) then
		Semi_Bar2_ShowBar();
		Semi_CoreOptionsCheckButton7Text:SetText(Semi_Core_String_CB7a);
	end
	if (not SF_EB_2_State) then
		Semi_Bar2_HideBar();
		Semi_CoreOptionsCheckButton7Text:SetText(Semi_Core_String_CB7b);
	end
end

function Semi_ExtraBar3_Options()
	SF_EB_3_State = Semi_CoreOptionsCheckButton8:GetChecked() or false;
	if (SF_EB_3_State) then
		Semi_Bar3_ShowBar();
		Semi_CoreOptionsCheckButton8Text:SetText(Semi_Core_String_CB8a);
	end
	if (not SF_EB_3_State) then
		Semi_Bar3_HideBar();
		Semi_CoreOptionsCheckButton8Text:SetText(Semi_Core_String_CB8b);
	end
end

function Semi_Grid_Choice_Options()
	SF_Grid_State = Semi_CoreOptionsCheckButton9:GetChecked() or false;
	Semi_Grid = SF_Grid_State;
	if (SF_Grid_State) then
		Semi_CoreOptionsCheckButton9Text:SetText(Semi_Core_String_CB9a);
	end
	if (not SF_Grid_State) then
		Semi_CoreOptionsCheckButton9Text:SetText(Semi_Core_String_CB9b);
	end
	Semi_GridChoice();
end

function Semi_LinkCastingBarToDragButton()
	if ( SF_Castbar_State ) then
		UIPARENT_MANAGED_FRAME_POSITIONS["CastingBarFrame"] = nil;
		CastingBarFrame:ClearAllPoints();
		CastingBarFrame:SetPoint("BOTTOMLEFT", SemiCastingBarDragButton, "BOTTOMLEFT");
	end
end

function Semi_Frames_Unlock()
	if ( Semicombat == false ) then
		if (SF_Castbar_State) then
			SemiCastingBarDragButton:Show();
		end
		if (IsAddOnLoaded("Semi_Player_Frame")) then
			SF_Player_Locked = false;
			SPF_PlayerFrameDragButton:Show();
		end
		if (IsAddOnLoaded("Semi_Target_Frame")) then
			SF_Target_Locked = false;
			SFTTargetFrameDragButton:Show();
		end
		if (IsAddOnLoaded("Semi_TargetofTarget_Frame")) then
			SF_TargetofTarget_Locked = false;
			SFTOTTargetofTargetFrameDragButton:Show();
		end
		if (IsAddOnLoaded("Semi_Action_Bars")) then
			if (Semiclass == "Shaman" and HasMultiCastActionBar) then
				SemiTotemBarDragButton:Show();
			end
			SemiMainMenuBarDragButton:Show();
			SemiBottomLeftBarDragButton:Show();
			SemiBottomRightBarDragButton:Show();
			SemiInventoryBagsDragButton:Show();
			SemiMicroMenuDragButton:Show();
		end	
		if (IsAddOnLoaded("Semi_Extra_Bars")) then
			if (Semi_Bar1_ActionBar) then
				Semi_Bar1_UnLockBars();
			end
			if (Semi_Bar2_ActionBar) then
				Semi_Bar2_UnLockBars();
			end
			if (Semi_Bar3_ActionBar) then
				Semi_Bar3_UnLockBars();
			end
		end
		if (IsAddOnLoaded("Semi_Pet_Bar")) then
			if SemiPetBar:IsShown() then
				Semi_Pet_Bar_UnLockBars();
			end
		end
		if (IsAddOnLoaded("Semi_Stance_Bar")) then
			if ShapeshiftButton1:IsShown() then
				SemiStanceBar_UnLockBars();
			end
		end
		SemiVehicleLeaveDragButton:Show();
	else
		DEFAULT_CHAT_FRAME:AddMessage("You can't unlock the frames during combat!");
	end

end

function Semi_Frames_Lock()
	if ( Semicombat == false ) then
		SemiCastingBarDragButton:Hide();
		SemiVehicleLeaveDragButton:Hide();
		if (IsAddOnLoaded("Semi_Player_Frame")) then
			SF_Player_Locked = true;
			SPF_PlayerFrameDragButton:Hide();
		end
		if (IsAddOnLoaded("Semi_Target_Frame")) then
			SF_Target_Locked = true;
			SFTTargetFrameDragButton:Hide();
		end
		if (IsAddOnLoaded("Semi_TargetofTarget_Frame")) then
			SF_TargetofTarget_Locked = true;
			SFTOTTargetofTargetFrameDragButton:Hide();
		end
		if (IsAddOnLoaded("Semi_Action_Bars")) then
			SemiMainMenuBarDragButton:Hide();
			SemiBottomLeftBarDragButton:Hide();
			SemiBottomRightBarDragButton:Hide();
			SemiInventoryBagsDragButton:Hide();
			SemiMicroMenuDragButton:Hide();
			if (Semiclass == "Shaman" and HasMultiCastActionBar) then
				SemiTotemBarDragButton:Hide();
			end
		end	
		if (IsAddOnLoaded("Semi_Extra_Bars")) then
			if (Semi_Bar1_ActionBar) then
				Semi_Bar1_LockBars();
			end
			if (Semi_Bar2_ActionBar) then
				Semi_Bar2_LockBars();
			end
			if (Semi_Bar3_ActionBar) then
				Semi_Bar3_LockBars();
			end
		end
		if (IsAddOnLoaded("Semi_Pet_Bar")) then
			if SemiPetBar:IsShown() then
				Semi_Pet_Bar_LockBars();
			end
		end
		if (IsAddOnLoaded("Semi_Stance_Bar")) then
			if ShapeshiftButton1:IsShown() then
				SemiStanceBar_LockBars();
			end
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage("You can't lock the frames during combat!");
	end
	
end

function Semi_Castbar_Options()
	SF_Castbar_State = Semi_CoreOptionsCheckButton4:GetChecked() or false;
	
		if ( SF_Castbar_State ) then
			CastingBarFrame:RegisterAllEvents();
			CastingBarFrame:Show();
			Semi_CoreOptionsCheckButton4Text:SetText(Semi_Core_String_CB4a);
			Semi_LinkCastingBarToDragButton();
			SemiCastingBarDragButton:Show();
		elseif (not SF_Castbar_State ) then
			CastingBarFrame:Hide();
			CastingBarFrame:UnregisterAllEvents();
			Semi_CoreOptionsCheckButton4Text:SetText(Semi_Core_String_CB4b);
			SemiCastingBarDragButton:Hide();
		end
	
	
end

function Semi_Gryphons_Options()
	SF_Gryphon_State = Semi_CoreOptionsCheckButton5:GetChecked() or false;
	
	if ( SF_Gryphon_State ) then
		MainMenuBarLeftEndCap:Show();
		MainMenuBarRightEndCap:Show();
		Semi_CoreOptionsCheckButton5Text:SetText(Semi_Core_String_CB5a);
	elseif (not SF_Gryphon_State) then
		MainMenuBarLeftEndCap:Hide();
		MainMenuBarRightEndCap:Hide();
		Semi_CoreOptionsCheckButton5Text:SetText(Semi_Core_String_CB5b);
	end
end

function Semi_LinkVehicleLeaveButtonToDragButton()
	MainMenuBarVehicleLeaveButton:ClearAllPoints();
	MainMenuBarVehicleLeaveButton:SetPoint("BOTTOMLEFT", SemiVehicleLeaveDragButton, "BOTTOMLEFT");
end

hooksecurefunc("UIParent_ManageFramePositions", Semi_LinkCastingBarToDragButton);
hooksecurefunc("UIParent_ManageFramePositions", Semi_LinkVehicleLeaveButtonToDragButton);

  --Functions for the Modules Menu
function Semi_PlayerFrame_Load_Options()
	SF_PlayerFrame_Load = Semi_CoreOptions_ModsCheckButton1:GetChecked() or false;
	if (SF_PlayerFrame_Load) and (IsAddOnLoaded("Semi_Player_Frame")) then
		Semi_CoreOptions_ModsCheckButton1Text:SetText(Semi_Core_Mods_String_CB1a);
	end
	if (not SF_PlayerFrame_Load) and (not IsAddOnLoaded("Semi_Player_Frame")) then
		Semi_CoreOptions_ModsCheckButton1Text:SetText(Semi_Core_Mods_String_CB1b);
	end
	if (SF_PlayerFrame_Load) and (not IsAddOnLoaded("Semi_Player_Frame")) then
		Semi_CoreOptions_ModsCheckButton1Text:SetText(Semi_Core_Mods_String_CB1c);
	end
	if (not SF_PlayerFrame_Load) and (IsAddOnLoaded("Semi_Player_Frame")) then
		Semi_CoreOptions_ModsCheckButton1Text:SetText(Semi_Core_Mods_String_CB1d);
	end
end

function Semi_TargetFrame_Load_Options()
	SF_TargetFrame_Load = Semi_CoreOptions_ModsCheckButton2:GetChecked() or false;
	if (SF_TargetFrame_Load) and (IsAddOnLoaded("Semi_Target_Frame")) then
		Semi_CoreOptions_ModsCheckButton2Text:SetText(Semi_Core_Mods_String_CB2a);
	end
	if (not SF_TargetFrame_Load) and (not IsAddOnLoaded("Semi_Target_Frame")) then
		Semi_CoreOptions_ModsCheckButton2Text:SetText(Semi_Core_Mods_String_CB2b);
	end
	if (SF_TargetFrame_Load) and (not IsAddOnLoaded("Semi_Target_Frame")) then
		Semi_CoreOptions_ModsCheckButton2Text:SetText(Semi_Core_Mods_String_CB2c);
	end
	if (not SF_TargetFrame_Load) and (IsAddOnLoaded("Semi_Target_Frame")) then
		Semi_CoreOptions_ModsCheckButton2Text:SetText(Semi_Core_Mods_String_CB2d);
	end
end

function Semi_TargetFrameToT_Load_Options()
	SF_TargetFrameToT_Load = Semi_CoreOptions_ModsCheckButton3:GetChecked() or false;
	if (SF_TargetFrameToT_Load) and (IsAddOnLoaded("Semi_TargetofTarget_Frame")) then
		Semi_CoreOptions_ModsCheckButton3Text:SetText(Semi_Core_Mods_String_CB3a);
	end
	if (not SF_TargetFrameToT_Load) and (not IsAddOnLoaded("Semi_TargetofTarget_Frame")) then
		Semi_CoreOptions_ModsCheckButton3Text:SetText(Semi_Core_Mods_String_CB3b);
	end
	if (SF_TargetFrameToT_Load) and (not IsAddOnLoaded("Semi_TargetofTarget_Frame")) then
		Semi_CoreOptions_ModsCheckButton3Text:SetText(Semi_Core_Mods_String_CB3c);
	end
	if (not SF_TargetFrameToT_Load) and (IsAddOnLoaded("Semi_TargetofTarget_Frame")) then
		Semi_CoreOptions_ModsCheckButton3Text:SetText(Semi_Core_Mods_String_CB3d);
	end
end

function Semi_Portrait_Options()
	SF_ClassIcons_Portrait = Semi_CoreOptions_ModsCheckButton4:GetChecked() or false;
	if (SF_ClassIcons_Portrait) and (IsAddOnLoaded("Semi_ClassIcons_Portrait")) then
		Semi_CoreOptions_ModsCheckButton4Text:SetText(Semi_Core_Mods_String_CB4a);
	end
	if (not SF_ClassIcons_Portrait) and (not IsAddOnLoaded("Semi_ClassIcons_Portrait")) then
		Semi_CoreOptions_ModsCheckButton4Text:SetText(Semi_Core_Mods_String_CB4b);
	end
	if (SF_ClassIcons_Portrait) and (not IsAddOnLoaded("Semi_ClassIcons_Portrait")) then
		Semi_CoreOptions_ModsCheckButton4Text:SetText(Semi_Core_Mods_String_CB4c);
	end
	if (not SF_ClassIcons_Portrait) and (IsAddOnLoaded("Semi_ClassIcons_Portrait")) then
		Semi_CoreOptions_ModsCheckButton4Text:SetText(Semi_Core_Mods_String_CB4d);
	end
end

function Semi_Action_Bars_Options()
	SF_ActionBars_Load = Semi_CoreOptions_ModsCheckButton5:GetChecked() or false;
	if (SF_ActionBars_Load) and (IsAddOnLoaded("Semi_Action_Bars")) then
		Semi_CoreOptions_ModsCheckButton5Text:SetText(Semi_Core_Mods_String_CB5a);
	end
	if (not SF_ActionBars_Load) and (not IsAddOnLoaded("Semi_Action_Bars")) then
		Semi_CoreOptions_ModsCheckButton5Text:SetText(Semi_Core_Mods_String_CB5b);
	end
	if (SF_ActionBars_Load) and (not IsAddOnLoaded("Semi_Action_Bars")) then
		Semi_CoreOptions_ModsCheckButton5Text:SetText(Semi_Core_Mods_String_CB5c);
	end
	if (not SF_ActionBars_Load) and (IsAddOnLoaded("Semi_Action_Bars")) then
		Semi_CoreOptions_ModsCheckButton5Text:SetText(Semi_Core_Mods_String_CB5d);
	end
end

function Semi_Extra_Bars_Options()
	SF_ExtraBars_Load = Semi_CoreOptions_ModsCheckButton6:GetChecked() or false;
	if (SF_ExtraBars_Load) and (IsAddOnLoaded("Semi_Extra_Bars")) then
		Semi_CoreOptions_ModsCheckButton6Text:SetText(Semi_Core_Mods_String_CB6a);
	end
	if (not SF_ExtraBars_Load) and (not IsAddOnLoaded("Semi_Extra_Bars")) then
		Semi_CoreOptions_ModsCheckButton6Text:SetText(Semi_Core_Mods_String_CB6b);
	end
	if (SF_ExtraBars_Load) and (not IsAddOnLoaded("Semi_Extra_Bars")) then
		Semi_CoreOptions_ModsCheckButton6Text:SetText(Semi_Core_Mods_String_CB6c);
	end
	if (not SF_ExtraBars_Load) and (IsAddOnLoaded("Semi_Extra_Bars")) then
		Semi_CoreOptions_ModsCheckButton6Text:SetText(Semi_Core_Mods_String_CB6d);
	end
end

function Semi_Pet_Bar_Options()
	SF_PetBar_Load = Semi_CoreOptions_ModsCheckButton7:GetChecked() or false;
	if (SF_PetBar_Load) and (IsAddOnLoaded("Semi_Pet_Bar")) then
		Semi_CoreOptions_ModsCheckButton7Text:SetText(Semi_Core_Mods_String_CB7a);
	end
	if (not SF_PetBar_Load) and (not IsAddOnLoaded("Semi_Pet_Bar")) then
		Semi_CoreOptions_ModsCheckButton7Text:SetText(Semi_Core_Mods_String_CB7b);
	end
	if (SF_PetBar_Load) and (not IsAddOnLoaded("Semi_Pet_Bar")) then
		Semi_CoreOptions_ModsCheckButton7Text:SetText(Semi_Core_Mods_String_CB7c);
	end
	if (not SF_PetBar_Load) and (IsAddOnLoaded("Semi_Pet_Bar")) then
		Semi_CoreOptions_ModsCheckButton7Text:SetText(Semi_Core_Mods_String_CB7d);
	end
end

function Semi_Stance_Bar_Options()
	SF_StanceBar_Load = Semi_CoreOptions_ModsCheckButton8:GetChecked() or false;
	if (SF_StanceBar_Load) and (IsAddOnLoaded("Semi_Stance_Bar")) then
		Semi_CoreOptions_ModsCheckButton8Text:SetText(Semi_Core_Mods_String_CB8a);
	end
	if (not SF_StanceBar_Load) and (not IsAddOnLoaded("Semi_Stance_Bar")) then
		Semi_CoreOptions_ModsCheckButton8Text:SetText(Semi_Core_Mods_String_CB8b);
	end
	if (SF_StanceBar_Load) and (not IsAddOnLoaded("Semi_Stance_Bar")) then
		Semi_CoreOptions_ModsCheckButton8Text:SetText(Semi_Core_Mods_String_CB8c);
	end
	if (not SF_StanceBar_Load) and (IsAddOnLoaded("Semi_Stance_Bar")) then
		Semi_CoreOptions_ModsCheckButton8Text:SetText(Semi_Core_Mods_String_CB8d);
	end
end

function Semi_CoreOptions_Mods_ReloadUI()
	local mod1, mod2, mod3, mod4;
	mod1 = Semi_CoreOptions_ModsCheckButton1:GetChecked() or false;
	mod2 = Semi_CoreOptions_ModsCheckButton2:GetChecked() or false;
	mod3 = Semi_CoreOptions_ModsCheckButton3:GetChecked() or false;
	mod4 = Semi_CoreOptions_ModsCheckButton4:GetChecked() or false;
	mod5 = Semi_CoreOptions_ModsCheckButton5:GetChecked() or false;
	mod6 = Semi_CoreOptions_ModsCheckButton6:GetChecked() or false;
	mod7 = Semi_CoreOptions_ModsCheckButton7:GetChecked() or false;
	
	if (not mod1) then
		DisableAddOn("Semi_Player_Frame");
	elseif (mod1) then
		EnableAddOn("Semi_Player_Frame");
		LoadAddOn("Semi_Player_Frame");
	end

	if (not mod2) then
		DisableAddOn("Semi_Target_Frame");
	elseif (mod2) then
		EnableAddOn("Semi_Target_Frame");
		LoadAddOn("Semi_Target_Frame");
	end

	if (not mod3) then
		DisableAddOn("Semi_TargetofTarget_Frame");
	elseif (mod3) then
		EnableAddOn("Semi_TargetofTarget_Frame");
		LoadAddOn("Semi_TargetofTarget_Frame");
	end

	if  (not mod4) then
		DisableAddOn("Semi_Core_ClassIcons_Portrait");
	elseif (mod4) then
		EnableAddOn("Semi_Core_ClassIcons_Portrait");
		LoadAddOn("Semi_Core_ClassIcons_Portrait");
	end
	
	if (not mod5) then
		DisableAddOn("Semi_Action_Bars");
	elseif (mod5) then
		EnableAddOn("Semi_Action_Bars");
		LoadAddOn("Semi_Action_Bars");
	end
	
	if (not mod6) then
		DisableAddOn("Semi_Extra_Bars");
	elseif (mod6) then
		EnableAddOn("Semi_Extra_Bars");
		LoadAddOn("Semi_Extra_Bars");
	end
	
	if (not mod7) then
		DisableAddOn("Semi_Pet_Bar");
	elseif (mod7) then
		EnableAddOn("Semi_Pet_Bar");
		LoadAddOn("Semi_Pet_Bar");
	end
	
	ReloadUI();
end





function Semi_Core_CleanUp()
	if (IsAddOnLoaded("Semi_Pet_Bar")) then
			if SemiPetBar:IsShown() then
				Semi_Pet_Bar_LockBars();
			end
	end
	if ( Semicombat == false ) then
		Semi_Frames_Lock();
	elseif ( Semicombat == true ) then          --Need to put in the check for modules and to alpha out the drag buttons they possess
		if ((SF_Player_Locked == false) or (SF_Target_Locked == false) or (SF_TargetofTarget_Locked == false)) then
			DEFAULT_CHAT_FRAME:AddMessage("The Options screen will open after leaving combat");
		end
		if (SF_Player_Locked == false) then
			DEFAULT_CHAT_FRAME:AddMessage("Player Frame is not locked in place, you can still move it");
		end
		if (SF_Target_Locked == false) then
			DEFAULT_CHAT_FRAME:AddMessage("Target Frame is not locked in place, you can still move it");
		end
		if (SF_TargetofTarget_Locked == false) then
			DEFAULT_CHAT_FRAME:AddMessage("Target of Target Frame is not locked in place, you can still move it");
		end
	end
end


function Semi_Core_OnEvent(self, event, ...)
	if ( event == "PLAYER_REGEN_DISABLED" ) then
		Semicombat = true;
		if (IsAddOnLoaded("Semi_Player_Frame")) then
			SPF_PlayerFrameDragButton:SetAlpha(0.1);
		end
		if (IsAddOnLoaded("Semi_Target_Frame")) then
			SFTTargetFrameDragButton:SetAlpha(0.1);
		end
		if (IsAddOnLoaded("Semi_TargetofTarget_Frame")) then		
			SFTOTTargetofTargetFrameDragButton:SetAlpha(0.1);
		end
		Semi_CoreOptions:Hide();
	else
		Semicombat = false;
		if (IsAddOnLoaded("Semi_Player_Frame")) then
			SPF_PlayerFrameDragButton:SetAlpha(.7);
		end
		if (IsAddOnLoaded("Semi_Target_Frame")) then
			SFTTargetFrameDragButton:SetAlpha(.7);
		end
		if (IsAddOnLoaded("Semi_TargetofTarget_Frame")) then
			SFTOTTargetofTargetFrameDragButton:SetAlpha(.7);
		end
		if ((SF_Player_Locked == false) or (SF_Target_Locked == false) or (SF_TargetofTarget_Locked == false)) then
			Semi_CoreOptions:Show();
		end
	end
	if ( event == "ADDON_LOADED" or event == "PLAYER_ENTERING_WORLD") then
		SemiCastingBarDragButton:Hide();
		SemiVehicleLeaveDragButton:Hide();
		Semi_LinkVehicleLeaveButtonToDragButton();
		Semi_Core_MinimapButton_Reposition();
		if (IsAddOnLoaded("Semi_Extra_Bars")) then
			Semi_Bar1_LockBars();
			Semi_Bar2_LockBars();
			Semi_Bar3_LockBars();
		end
		if ( SF_Castbar_State ) then
			CastingBarFrame:RegisterAllEvents();
			CastingBarFrame:Show();
			Semi_LinkCastingBarToDragButton();
		elseif (not SF_Castbar_State ) then
			CastingBarFrame:Hide();
			CastingBarFrame:UnregisterAllEvents();
		end
		if (not SF_Gryphon_State) then
			MainMenuBarLeftEndCap:Hide();
			MainMenuBarRightEndCap:Hide();
		elseif (SF_Gryphon_State) then
			MainMenuBarLeftEndCap:Show();
			MainMenuBarRightEndCap:Show();
		end
		Semi_Player_Scale_On_Change(Semi_Player_Scale);
	end
end

function Semi_Core_MinimapButton_Reposition()
	if (Semi_Core_MinimapPos == "" or Semi_Core_MinimapPos == "nil" or Semi_Core_MinimapPos == nil) then
		Semi_Core_MinimapPos = 45;
	end
	Semi_CoreMinimapButton:SetPoint("TOPLEFT","Minimap","TOPLEFT",52-(80*cos(Semi_Core_MinimapPos)),(80*sin(Semi_Core_MinimapPos))-52);
end

function Semi_CoreMinimapButton_DraggingFrame_OnUpdate()

	local xpos, ypos = GetCursorPosition();
	local xmin = Minimap:GetLeft();
	local ymin = Minimap:GetBottom();

	xpos = (xmin-xpos/UIParent:GetScale()+70); -- get coordinates as differences from the center of the minimap
	ypos = (ypos/UIParent:GetScale()-ymin-70);

	Semi_Core_MinimapPos = (math.deg(math.atan2(ypos,xpos))); -- save the degrees we are relative to the minimap center
	Semi_Core_MinimapButton_Reposition(); -- move the button
end

function Semi_CoreMinimapButton_LeftClick()

		if ( Semicombat == false ) then
			if  (Semi_CoreOptions:IsShown()) then
				Semi_CoreOptions:Hide();
			else 
				Semi_CoreOptions:Show();
				Semi_CoreOptions_Mods:Hide();
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage("You can't open the option screen during combat!");
		end
end

function Semi_CoreMinimapButton_RightClick()

		if ( Semicombat == false ) then
			if (Semi_CoreOptions_Mods:IsShown()) then
				Semi_CoreOptions_Mods:Hide();
			else
				Semi_CoreOptions_Mods:Show();
				Semi_CoreOptions:Hide();
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage("You can't open the module selction menu during combat!");
		end

end




