--Initial Variable settings, if the variable is nil it will use these values
SF_Pet_Bar = true;
SF_Pet_Bar_Locked = true;
Semipetbarscale = 1;

	function Semi_Pet_Bar_OnLoad(self)
		SemiPetBar_HidePetArt();
		
		SlashCmdList["SEMI_PET_BARCOMMAND"] = SemiPetBar_SlashHandler;
		SLASH_SEMI_PET_BARCOMMAND1 = "/semipet";

		self:RegisterEvent("PLAYER_ENTERING_WORLD");
		self:RegisterEvent("ADDON_LOADED");

	end

	function Semi_Pet_Bar_OnEvent(self, event, ...)
		if ( event == "PLAYER_ENTERING_WORLD" or event=="ADDON_LOADED" ) then
			if ( SF_Pet_Bar_Locked ) then
				Semi_Pet_Bar_LockBars();
			else
				Semi_Pet_Bar_UnLockBars();
			end
		end
		SetPetBarScale(Semipetbarscale);
	end

	function SemiPetBar_HidePetArt()
		PetActionBarFrame:EnableMouse("false");
		SlidingActionBarTexture0:SetAlpha(0);
		SlidingActionBarTexture1:SetAlpha(0);
	end

	function Semi_Construct_Pet_Bar()
		for i=1, 10 do
			pet_button = _G["PetActionButton"..i];
			if (pet_button ~= nil) then
				pet_button:ClearAllPoints();
				x_coord = 0 + ((i - 1) * 38);
				y_coord = 0;
				pet_button:SetPoint("BOTTOMLEFT", SemiPetBar, "BOTTOMLEFT", x_coord, y_coord);
			end
		end
	end

	function Semi_Link_Pet_BarToDragButton()
		SemiPetBar:ClearAllPoints();
		SemiPetBar:SetPoint("BOTTOMLEFT", SemiPetBarDragButton, "TOPRIGHT");
		if ( SF_Pet_Bar_Locked ) then
			Semi_Pet_Bar_LockBars();
		else
			Semi_Pet_Bar_UnLockBars();
		end
		SetPetBarScale(Semipetbarscale);	
	end
	
	function SetPetBarScale(scale)
		for i=1, 10 do
			_G["PetActionButton"..i]:SetScale(scale);
		end
	end

	function Semi_Pet_Bar_LockBars()
	    SemiPetBarDragButton:SetAlpha(0);
		SemiPetBarDragButton:EnableMouse("false");
		SF_Pet_Bar_Locked = true;
	end


	function Semi_Pet_Bar_UnLockBars()
		SemiPetBarDragButton:SetAlpha(1);
	    SemiPetBarDragButton:EnableMouse("true");
		SF_Pet_Bar_Locked = false;
	end


-----------------------------------------------------------------------------------------------------------------

-----------------------------------------------------------------------------------------------------------------

	function SemiPetBar_SlashHandler(msg)
		local _, _, command, args, _ = string.find(msg, "^(%w+)%s*(.*)$");
		if ( command == "scale" and args ) then
			Semipetbarscale = args;
			DEFAULT_CHAT_FRAME:AddMessage("The Scale for the Pet Bar is now "..Semipetbarscale);
			SetPetBarScale(Semipetbarscale);
		else
			DEFAULT_CHAT_FRAME:AddMessage("/semipet |cff00BFFFscale #|r - Scale the Pet Bar. ex: |cff00BFFF/semipet scale 1.3|r (default is 1)");
			DEFAULT_CHAT_FRAME:AddMessage(" ***|cffFFD700Individual frames are locked/unlocked with the interface actionbar lock.|r***");
		end
	end
